<script lang="ts">
  import { Alert, Badge, Table } from "@sveltestrap/sveltestrap";
  import { Gql } from "@db";
  import Feedback from "./Feedback.svelte";
  import type { Team, TeamUser } from "@models/Team";
  import type { ScoreBoardServiceStatus } from "@models/Service";
  import { ServiceFeedbackQuery } from "@models/Service";
  import { EventRole } from "@auth/models";
  import { keycloak, eventId } from "@stores";
  import { createKanbanTask, KanbanQuery, type KanbanTask } from "@models/Kanban";
  import { getTeammates } from "../../models/Team";
  import { onMount } from "svelte";
  import AssignTaskModal from "@components/TaskBoard/AssignTaskModal.svelte";
  import TaskDetailModal from "@components/TaskBoard/TaskDetailModal.svelte";
  import { getNotificationsContext } from "svelte-notifications";

  const { addNotification } = getNotificationsContext();

  let scoreboardFeedback: Array<ScoreBoardServiceStatus>;
  let currentSub: () => void | null = null;
  let teammates: TeamUser[] = [];
  let assignTask: (task_id?: string | undefined) => void;
  let showModal: (task_id?: string | undefined) => void;
  let tasks: KanbanTask[] = [];
  export let teamId;

  $: scoreboardFeedback = Array<ScoreBoardServiceStatus>();
  $: initScoreboardFeedback({ id: teamId });

  async function initScoreboardFeedback(team: { id: string }) {
    if (typeof currentSub === "function") {
      currentSub();
      currentSub = null;
    }

    currentSub = Gql.subscribeSimple<{ scoreboard_service_status: Array<ScoreBoardServiceStatus> }>(
      `subscription ${ServiceFeedbackQuery(
        {id: $eventId},
        team,
        $keycloak.authenticated && $keycloak.isRole(EventRole.Staff),
        // Note EventAdmin isn't strictly required, but we don't need to
        // pollute the view for everyone
        $keycloak.authenticated && $keycloak.isRole(EventRole.EventAdmin)
      )}`,
      (value) => (scoreboardFeedback = value.scoreboard_service_status)
    );
  }

  onMount(async () => {
    teammates = teamId ? await getTeammates(teamId) : [];
    await Gql.subscribeSimple(`subscription ${KanbanQuery}`, (data) => {
      tasks = data.scoreboard_kanban;
    });
  });

  async function createServiceKanbanTask(sf: ScoreBoardServiceStatus) {
    if (!sf.check) {
      return;
    }
    await createKanbanTask({
      assignee_id: $keycloak.tokenParsed?.sub,
      created_by: $keycloak.tokenParsed!.sub!,
      title: `[Infra] Fix ${sf.check.display_name}`,
      description: `Resolve the infrastructure problem:\n\n> ${
        sf?.participant?.feedback ? sf.participant.feedback.replaceAll("\n", "\n> ") : "Unspecified problem."
      }`,
      status: "In Progress",
      team_id: teamId,
      event_id: $eventId,
      check_id: sf.check.id
    });

    addNotification({
      text: `Task Created & Self-Assigned`,
      position: "bottom-right",
      removeAfter: 3000
    });
  }
</script>

<AssignTaskModal bind:show={assignTask} {teammates} {tasks} />
<TaskDetailModal bind:show={showModal} {tasks} {teammates} assignTask={(id) => assignTask(id)} />

<!-- If we don't see the staff property default to participant -->
{#if scoreboardFeedback.length > 0}
  <Table>
    <tbody>
    {#each scoreboardFeedback as sf}
      <!-- Header Row -->
      <tr>
        <td>
          <h5 class="d-inline-block">
            {sf.check.display_name}
            <Badge color="secondary">{sf.result_code}</Badge>
          </h5>
          {#if sf.team.id == teamId  && sf.check.id && (sf.result_code == 'partial' || sf.result_code == 'failure' || sf.result_code == 'timeout')}
            {#if !tasks.find((t) => t.check_id == sf.check.id && t.status !== 'Completed')}
              <small class="clickable d-inline-block" on:click={() => createServiceKanbanTask(sf)}>
                <Badge color="success">Create Task</Badge>
              </small>
            {/if}
            {#if tasks.find((t) => t.check_id == sf.check.id)}
              <small
                class="clickable d-inline-block"
                on:click={() => showModal(tasks.find((t) => t.check_id == sf.check.id)?.id)}
              >
                <Badge color="info">View Task</Badge>
              </small>
            {/if}
          {/if}
        </td>
      </tr>

      <!-- Participant Feedback Row -->
      <tr>
        <td>
          {#if sf.participant}
            <Feedback feedback={sf.participant} />
          {:else}
            <Alert color="warning">No Feedback Available!</Alert>
          {/if}
        </td>
      </tr>

      <!-- Staff Feedback -->
      {#if sf.staff}
        <tr>
          <td class="border border-warning">
            <Badge color="warning">Staff Feedback</Badge>
            <Feedback feedback={sf.staff} />
          </td>
        </tr>
      {/if}
      <!-- Scoring Execution Details -->
      {#if sf.data}
        <tr>
          <td class="border border-danger">
            <Badge color="danger">Execution Details</Badge>
            <Feedback feedback={sf.data} />
          </td>
        </tr>
      {/if}
    {/each}
    </tbody>
  </Table>
{:else if teamId}
  <p>No feedback available.</p>
{/if}

<style>
    /* Unset row-specific items for this component */
    .table tbody tr:hover {
        background-color: unset;
    }

    .table tbody tr:nth-of-type(2n + 1) {
        background-color: unset;
    }
</style>
